#include <Wire.h>
                                                                         
float Vout = 0.00;
float Vin = 0.00;
float R1 = 100000.0; // resistance of R1 (100K) 
float R2 = 10000.0; // resistance of R2 (10K) 
int val = 0;

int LED_3 = 3;
int RELAY_4 = 4;

int LED_5 = 5; // RED
int LED_6 = 6;
int LED_7 = 7;
int LED_8 = 8;
int LED_9 = 9;

int photocellPin = 0;     // the cell and 10K pulldown are connected to a0
int photocellReading;     // the analog reading from the sensor divider

void setup() {
  pinMode(LED_3, OUTPUT);
  pinMode(RELAY_4, OUTPUT);
  digitalWrite(RELAY_4, HIGH);
  pinMode(photocellPin, INPUT);
  
  pinMode(LED_5, OUTPUT);
  pinMode(LED_6, OUTPUT);
  pinMode(LED_7, OUTPUT);
  pinMode(LED_8, OUTPUT);
  pinMode(LED_9, OUTPUT);

  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  pinMode(A1, INPUT); //assigning the input port    
}

String CDS_val = "";

void loop() {
  // CDS Reading - Condition #1
  photocellReading = analogRead(photocellPin); 
  Serial.print("Analog reading = ");
  Serial.println(photocellReading);     // the raw analog reading
  CDS_val = (String) photocellReading;

  if (photocellReading < 100) { 
    for (int i=0;i<10;i++) {
      digitalWrite(LED_3, HIGH);
      delay(100);                       // wait for a second
      digitalWrite(LED_3, LOW);
      delay(100);                       // wait for a second
    }
  }
  else {
    digitalWrite(LED_3, HIGH);
    delay(1000);
    digitalWrite(RELAY_4, LOW);
  }  
  
  val = analogRead(A1);//reads the analog input
  Vout = (val * 5.0) / 1024.0; // formula for calculating voltage out i.e. V+, here 5.00
  Vin = Vout / (R2/(R1+R2)); // formula for calculating voltage in i.e. GND
  if (Vin < 0.09)//condition 
  {
     Vin=0.0;//statement to quash undesired reading !
  }                                                              
                                                  
  Serial.print("Voltage is: ");                                           
  Serial.print(Vin); 
  Serial.print("V\n"); 

  // 4.1~3.9 G, 3.8~3.6 G, 3.5~3.3 Y, 3.2~3.0 Y, 3.0 < R 
  if (Vin < 3.00) {
    digitalWrite(LED_5, HIGH); // RED
    digitalWrite(LED_6, LOW);
    digitalWrite(LED_7, LOW);
    digitalWrite(LED_8, LOW);
    digitalWrite(LED_9, LOW);
    delay(1000);
    digitalWrite(RELAY_4, LOW);
  }
  if (Vin >= 3.00 && Vin < 3.2) {
    digitalWrite(LED_5, LOW); // RED
    digitalWrite(LED_6, HIGH); // YELLOW
    digitalWrite(LED_7, LOW);
    digitalWrite(LED_8, LOW);
    digitalWrite(LED_9, LOW);
  }
  if (Vin >= 3.2 && Vin < 3.5) {
    digitalWrite(LED_5, LOW); // RED
    digitalWrite(LED_6, LOW); // YELLOW
    digitalWrite(LED_7, HIGH); // YELLOW
    digitalWrite(LED_8, LOW);
    digitalWrite(LED_9, LOW);
  }
  if (Vin >= 3.5 && Vin < 3.8) {
    digitalWrite(LED_5, LOW); // RED
    digitalWrite(LED_6, LOW); // YELLOW
    digitalWrite(LED_7, LOW); // YELLOW
    digitalWrite(LED_8, HIGH); // GREEN
    digitalWrite(LED_9, LOW);
  }
  if (Vin >= 3.8) {
    digitalWrite(LED_5, LOW); // RED
    digitalWrite(LED_6, LOW); // YELLOW
    digitalWrite(LED_7, LOW); // YELLOW
    digitalWrite(LED_8, LOW); // GREEN
    digitalWrite(LED_9, HIGH); // GREEN
  }
  delay(1000);
}
